## ghc 7.4.0.20111219

=== libraries/dph/dph-examples/Makefile ===
# Makes the dph-examples.cabal file from its template.

# Package dependencies for DPH examples.
DPH_DEPENDS = \
        base         	== 4.4.*, \
        vector       	== 0.9.*, \
        random       	== 1.0.*, \
        old-time     	== 1.0.*, \
	containers      == 0.4.*, \
        dph-base     	== 0.5.*, \
        dph-prim-par	== 0.5.*, \
        dph-lifted-vseg	== 0.5.*, \
	HUnit           == 1.2.*


# Options for compiling DPH examples.
DPH_OPTIONS= \
        -rtsopts \
        -threaded \
	-fllvm \
        -Odph \
        -package dph-lifted-vseg \
        -fcpr-off \
	-fno-liberate-case \
	-fno-spec-constr \
        -fsimpl-tick-factor=1000 


.PHONY : all
all : dph-examples.cabal
	cabal configure --user
	cabal build


# Make the cabal file from the tempalate by substituting in the above config.
dph-examples.cabal : dph-examples.template Makefile
	@echo "* Making dph-examples.cabal"
	@cpp 	-P -undef \
		-DDPH_DEPENDS="$(DPH_DEPENDS)" \
		-DDPH_OPTIONS="$(DPH_OPTIONS)" \
		dph-examples.template dph-examples.cabal

=== libraries/dph/dtrace/Makefile ===
libdph-trace.dylib: dph-trace.h dph-trace.c
	gcc -dynamiclib -o $@ -current_version 1.0 -compatibility_version 1.0 dph-trace.c
	install_name_tool -id `pwd`/libdph-trace.dylib $@

%.h: %.d
	dtrace -h -s $^

clean:
	rm -f libdph-trace.dylib dph-trace.h dph-trace.o

=== libraries/dph/examples/Makefile ===
# SUBDIRS = barnesHut concomp dotp primes primespj qsort quickhull smvm sumsq
# we currently don't have all benchmarks working
SUBDIRS = sumsq dotp smvm words

DRIVER = runbench.hs

.PHONY: all bench clean

all: bench
	@for i in $(SUBDIRS) ; do \
	  echo $(MAKE) -C $$i;    \
	  $(MAKE) -C $$i;         \
	done
	chmod a+x $(DRIVER)

bench:
	$(MAKE) -C lib

clean:
	@for i in $(SUBDIRS) ; do     \
	  echo $(MAKE) -C $$i clean;  \
	  $(MAKE) -C $$i clean;       \
	done
	$(MAKE) -C lib clean

=== libraries/dph/make/Makefile ===
# The DPH build system.
#
#   (Build targets)
#       all             -- build the library and examples.
#       packages        -- build   the cabal packages.
#       install         -- install the cabal packages.
#
#       front           -- create stub packages under ./build for the frontend.
#       sdist           -- create packages under ./sdist ready for uploading to Hackage
#
#
#   (Cleaning up)
#       clean           -- clean everything
#

include make/config.mk


# -- Mega Targets -------------------------------------------------------------
.PHONY : all
all : 
	@$(MAKE) -f make/Makefile deps
	@$(MAKE) -f make/Makefile -j $(THREADS_MAKE) \
		prim-seq prim-par \
		lifted-$(FRONTEND)

test :
	@$(MAKE) -f make/Makefile deps
	@$(MAKE) -f make/Makefile test-prims
        

# -- Targets ------------------------------------------------------------------
# Unlifted array primitives (backend)
.PHONY : prim-seq 
prim-seq : \
	dph-prim-seq/Data/Array/Parallel/Unlifted/Sequential.o


.PHONY : prim-par
prim-par : \
	dph-prim-par/Data/Array/Parallel/Unlifted/Parallel.o \
	dph-prim-par/Data/Array/Parallel/Unlifted/Distributed.o 
        

# Lifted array primitives (frontend)
.PHONY : lifted-copy
lifted-copy : dph-lifted-copy/Data/Array/Parallel.o


.PHONY : lifted-vseg 
lifted-vseg : dph-lifted-vseg/Data/Array/Parallel/PArray.o


# -- Source Files -------------------------------------------------------------
# Dirs that contain real source files that we want to build.
dph_src_dirs \
 =      dph-base \
        dph-prim-seq \
        dph-prim-par \
        dph-lifted-$(FRONTEND)

# Dirs that contain .h files that we may way to #include
dph_inc_dirs      = dph-base/include dph-prim-interface/interface

# Gather up all the .hs files.
dph_src_dirs_data = $(patsubst %,%/Data,$(dph_src_dirs))
dph_src_hs_all    = $(shell find $(dph_src_dirs_data) -name "*.hs" -follow)
dph_src_hs        = $(filter-out %/Unlifted.hs,$(dph_src_hs_all))


# -- Default Rules -----------------------------------------------------------
%.hi : %.o
	@true
        
%.o : %.hs
	@echo "* Compiling $<"
	@$(GHC_DPH) $(GHC_EXTS) \
                $(GHC_OPTS) \
                $(patsubst %,-I%,$(dph_inc_dirs)) \
                $(patsubst %,-i%,$(dph_src_dirs)) \
                $(patsubst %,-package %,$(GHC_PACKAGES)) \
                -c $<


# -- Other Targets ------------------------------------------------------------
include make/targets/clean.mk
include make/targets/deps.mk
include make/targets/packages.mk
include make/targets/test.mk
include make/targets/examples.mk

-include make/Makefile.deps.inc

=== libraries/random/Benchmark/Makefile ===


#OPTS= -O2 -Wall -XCPP
OPTS= -O2 -Wall -XCPP -Werror

all: lib bench

lib:
	(cd .. && ghc $(OPTS) --make System/Random.hs)

bench:
	ghc $(OPTS) -i.. --make SimpleRNGBench.hs 

# When benchmarking against other packages installed via cabal it is
# necessary to IGNORE the System/Random.hs files in the current directory.
# (Otherwise instances of RandomGen are confused.)
bench2:
	ghc $(OPTS) -DTEST_COMPETITORS --make SimpleRNGBench.hs 

clean:
	rm -f *.o *.hi SimpleRNGBench
#	cabal clean
#	(cd Benchmark/ && rm -f *.o *.hi SimpleRNGBench)
#	(cd System/    && rm -f *.o *.hi SimpleRNGBench)

=== libraries/random/tests/Makefile ===
# This Makefile runs the tests using GHC's testsuite framework.  It
# assumes the package is part of a GHC build tree with the testsuite
# installed in ../../../testsuite.

TOP=../../../testsuite
include $(TOP)/mk/boilerplate.mk
include $(TOP)/mk/test.mk


# Build tests locally without the central GHC testing infrastructure:
local:
	ghc --make rangeTest.hs
	ghc --make random1283.hs

=== libraries/dph/dph-test/old/Makefile ===
GHC = ../../../../inplace/bin/ghc-stage2

HC      = $(GHC)
HCFLAGS = -package QuickCheck -package template-haskell -package regex-compat \
          -fth -XGeneralizedNewtypeDeriving -XTypeSynonymInstances -v0
OPTFLAGS = -O2 -funbox-strict-fields -fliberate-case-threshold100
PARFLAGS = -package dph-prim-par
SEQFLAGS = -package dph-prim-seq

TESTSUITE = Testsuite/Utils.hs \
            Testsuite/Testcase.hs \
            Testsuite/Preproc.hs \
            Testsuite.hs

TESTSUITE_OBJS = $(TESTSUITE:.hs=.o)

TESTS = $(wildcard tests/*.hs)
TEST_MODS = $(notdir $(TESTS))
OPT = $(TEST_MODS:.hs=-opt)
UNOPT = $(TEST_MODS:.hs=-unopt)
# we want the tests to be run in the right order
ALL = $(TEST_MODS:.hs=-all)

TESTMAIN = 'System.Environment.withArgs (words "$(run)") main'

.PHONY: default unopt opt all testsuite

default: unopt

all: $(ALL)

unopt: $(UNOPT)

opt: $(OPT)

testsuite: $(TESTSUITE_OBJS)

Testsuite.o: $(filter-out Testsuite.o,$(TESTSUITE_OBJS))

%.o : %.hs
	$(HC) -c $< $(HCFLAGS) $(PARFLAGS)

%-opt.o: %.hs testsuite
	$(HC) -o $@ -c $< $(HCFLAGS) $(PARFLAGS) $(OPTFLAGS)

%.hi: %.o
	@:

$(TEST_OBJS) : testsuite

%-all: %-unopt %-opt
	@:

%-unopt:
	@echo "======== Testing  $(patsubst %-unopt,%,$@) (parallel, interpreted) ========"
	@$(HC) -e $(TESTMAIN) $(patsubst %-unopt,tests/%.hs,$@) $(HCFLAGS) $(PARFLAGS) \
		| tee $@.log | { grep -v '\.\.\. pass' || true; }
	@echo "======== Finished $(patsubst %-unopt,%,$@) (parallel, interpreted) ========"
	@echo "======== Testing  $(patsubst %-unopt,%,$@) (sequential, interpreted) ========"
	@$(HC) -e $(TESTMAIN) $(patsubst %-unopt,tests/%.hs,$@) $(HCFLAGS) $(SEQFLAGS) \
		| tee $@.log | { grep -v '\.\.\. pass' || true; }
	@echo "======== Finished $(patsubst %-unopt,%,$@) (sequential, interpreted) ========"

# Throws warnings
%-opt: tests/%-opt.o
	@echo "======== Testing  $(patsubst %-opt,%,$@) (optimised) ========"
	@$(HC) -o tst $(HCFLAGS) $(PARFLAGS) $< $(TESTSUITE_OBJS)
	@./tst | tee $@ | { grep -v '\.\.\. pass' || true; }
	@rm -f tst $<
	@echo "======== Finished $(patsubst %-opt,%,$@) (optimised) ========"

=== libraries/dph/examples/delaunay/Makefile ===
TOPDIR = ..
BINARIES = delaunay delaunaySVG

HCCFLAGS = -optc-O3

delaunay_DPH = delaunay
delaunay_SOURCES = Main.hs SVG.hs Types.hs Sort.hs Hull.hs Delaunay.hs

delaunaySVG_DPH = delaunaySVG
delaunaySVG_SOURCES = MainSVG.hs SVG.hs Types.hs Sort.hs Hull.hs Delaunay.hs

include $(TOPDIR)/mk/test.mk

=== libraries/dph/examples/regularArrays/Makefile ===
TOPDIR = ..
BINARIES = raBench raTest saBench laplace mmult fft

# -----------------
raBench_DPH 	= raBench
raBench_SOURCES =  ReglibBench.hs Array.hs ArrayExamples.hs DArray.hs DArrayExamples.hs 

raBench_seq_FLAGS = -fsimplifier-phases=3 -package dph-base
raBench_par_FLAGS = -fsimplifier-phases=3 -package dph-base


# -----------------
raTest_DPH 	= raTest
raTest_SOURCES	=  ReglibTest.hs Array.hs ArrayExamples.hs DArray.hs DArrayExamples.hs 

raTest_seq_FLAGS = -fsimplifier-phases=3 -package dph-base
raTest_par_FLAGS = -fsimplifier-phases=3 -package dph-base



# -----------------
saBench_DPH 	= saBench
saBench_SOURCES =  ArrayBench.hs

saBench_seq_FLAGS = -fsimplifier-phases=3 -package dph-base
saBench_par_FLAGS = -fsimplifier-phases=3 -package dph-base



# ----------------
laplace_DPH	= laplace
laplace_SOURCES	= \
	examples/laplace/Main.hs \
	examples/laplace/SolveArray.hs \
	examples/laplace/SolveDArray.hs \
	examples/laplace/SolveCArray.hs \
	examples/laplace/SolveCArrayFlatDim.hs \
	examples/lib/PPM.hs \

laplace_seq_FLAGS = -iexamples/laplace -iexamples/lib -fsimplifier-phases=3 -package dph-base
laplace_par_FLAGS = -iexamples/laplace -iexamples/lib -fsimplifier-phases=3 -package dph-base


	

# -----------------
mmult_DPH	= mmult
mmult_SOURCES	= \
	examples/mmult/Main.hs
	
mmult_seq_FLAGS = -iexamples/mmult -iexamples/lib -fsimplifier-phases=3 -package dph-base
mmult_par_FLAGS = -iexamples/mmult -iexamples/lib -fsimplifier-phases=3 -package dph-base

# -----------------
fft_DPH		= fft
fft_SOURCES	= \
	examples/fft/Main.hs \
	examples/fft/FFTCArray.hs \
	examples/lib/StrictComplex.hs

fft_seq_FLAGS = -iexamples/fft -iexamples/lib
fft_par_FLAGS = -iexamples/fft -iexamples/lib

include $(TOPDIR)/mk/test.mk



# C versions --------------------------------------------------------------------------------------
laplacec_HEADER  = \
	examples/libc/Matrix.h \
	examples/libc/ColorRamp.h \
	examples/libc/Timing.h

laplacec_SOURCES = \
	examples/laplacec/Main.c \
	examples/libc/Matrix.c  \
	examples/libc/ColorRamp.c \
	examples/libc/Timing.c
	
seq/laplacec : $(laplacec_SOURCES) $(laplacec_HEADER)
	gcc -std=c99 -O2 -Iexamples/libc $(laplacec_SOURCES) -o seq/laplacec



mmultc_HEADER  = \
	examples/libc/Matrix.h \
	examples/libc/Timing.h

mmultc_SOURCES = \
	examples/mmultc/Main.c \
	examples/libc/Matrix.c \
	examples/libc/ColorRamp.c \
	examples/libc/Timing.c
		
seq/mmultc : $(mmultc_SOURCES) $(mmultc_HEADER)
	gcc -std=c99 -O2 -Iexamples/libc $(mmultc_SOURCES) -o seq/mmultc

=== libraries/dph/dph-examples/examples/spectral/QuickHull/c/Makefile ===

quickhull : Main.c QuickHull.c SVG.c Timing.c Timing.h Vector.h
	gcc --std=c99 -O2 -o quickhull Main.c QuickHull.c SVG.c Timing.c

=== debian/changelog ===
ghc (7.4.0.20111219-2) experimental; urgency=low

  * Fix building bundeled haddock out-of-tree (We need to re-think this
    approach).
  * Drop patches/lpthread-bootstrap-workaround, probably not needed any
    more. Also drop autoconf dependency.

 -- Joachim Breitner <nomeata@debian.org>  Fri, 23 Dec 2011 09:23:42 +0100

ghc (7.4.0.20111219-1) experimental; urgency=low

  * New upstream release (AKA 7.4.1-rc1)
    + Closes: #635587 (GHCi linker could not find libstdc++)
    + Closes: #514720 (cabal installation wrecks permissions) (was actually
      closed earlier, I think)
    + Closes: #533022 (Data.Word should define instances of Random for each
      type)

 -- Joachim Breitner <nomeata@debian.org>  Thu, 22 Dec 2011 14:34:50 +0100

=== debian/control ===
Source: ghc
Section: haskell
Priority: extra
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders: Joachim Breitner <nomeata@debian.org>
Standards-Version: 3.9.2
Build-Depends:
  debhelper (>= 7),
  libgmp-dev,
  devscripts,
  ghc,
  grep-dctrl,
  autotools-dev,
  gcc (>= 4:4.2),
  libffi-dev,
  pkg-config,
  xsltproc,
  docbook-xsl,
  docbook-xml,
  binutils (>= 2.19.51.20090508) [arm armel],
  libncurses5-dev
Build-Conflicts:
  ccache
Homepage: http://haskell.org/ghc/

Package: ghc
Architecture: any
Depends: gcc (>= 4:4.2), libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
Replaces: ghc6 (<< 7)
Conflicts: ghc6 (<< 7)
Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Replaces: ghc6-prof (<< 7)
Conflicts: ghc6-prof (<< 7)
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Suggests: haskell-doc
Provides: ${provided-docs}
Replaces: ghc6-doc (<< 7)
Conflicts: ghc6-doc (<< 7), ghc (<= 7.0.3-1)
Depends: ${haddock:Depends}, ${misc:Depends}, perl
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

Package: ghc-dynamic
Architecture: i386 amd64
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Dynamic libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found in the `haskell-doc'
 package.  Alternatively, there is an online version at
 http://haskell.org/onlinereport/.
 .
 This package has dynamically linkable, shared versions of the
 libraries included with GHC.  Currently, they are available only on
 i386 and amd64 architectures.

Package: ghc-haddock
Architecture: any
Provides: haddock, ${haddock:Provides}
Conflicts: haddock
Depends: ghc (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Homepage: http://www.haskell.org/haddock/
Description: Documentation tool for annotated Haskell source code
 Haddock is a tool for automatically generating documentation from
 annotated Haskell source code.  It is primary intended for documenting
 libraries, but it should be useful for any kind of Haskell code.
 .
 Haddock lets you write documentation annotations next to the
 definitions of functions and types in the source code, in a syntax
 that is easy on the eye when writing the source code (no heavyweight
 mark-up).  The documentation generated by Haddock is fully hyperlinked:
 click on a type name in a type signature to go straight to the
 definition, and documentation, for that type.
 .
 Haddock can generate documentation in multiple formats; currently HTML
 is implemented, and there is partial support for generating DocBook.
 .
 This package contains Haddock version 2.9.4.

Package: ghc6
Architecture: all
Depends: ghc, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6 to the
 package name ghc, and can safely be removed.

Package: ghc6-doc
Architecture: all
Depends: ghc-doc, ${misc:Depends}
Section: doc
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-doc to the
 package name ghc-doc, and can safely be removed.

Package: ghc6-prof
Architecture: all
Depends: ghc-prof, ${misc:Depends}
Description: transitional dummy package
 This package ensures a smooth transition from the package name ghc6-prof to the
 package name ghc-prof, and can safely be removed.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# Commented out for now.  The build scripts don't recognise i486 as an
# architecture and cross compiling isn't supported anyway.
#ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
#  confflags += --build $(DEB_HOST_GNU_TYPE)
#else
#  confflags += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
#endif

ProjectVersion=$(shell cat VERSION)

GHC=$(firstword $(shell bash -c "type -p ghc"))
EXTRA_CONFIGURE_FLAGS=--with-ghc="$(GHC)"
BUILD_HADDOCK_DOCS=YES

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

configure: configure-stamp
configure-stamp:
	dh_testdir

	rm -f mk/build.mk
	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
	echo "HADDOCK_DOCS := YES" >> mk/build.mk
	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc))
	echo "GhcUnregisterised=NO" >> mk/build.mk
else
	echo "GhcUnregisterised=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
	echo "GhcWithInterpreter=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf alpha ia64))
	echo "UseLibFFIForAdjustors=YES" >> mk/build.mk
endif
ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
endif
# proper fix for #360177
ifeq (ppc64,$(DEB_HOST_ARCH))
	echo "SRC_HC_OPTS += -optc-mminimal-toc" >> mk/build.mk
endif
ifneq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
#	echo "GhcStage1HcOpts += -DDEBUG" >> mk/build.mk
#	echo "GhcStage2HcOpts += -DDEBUG" >> mk/build.mk
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -Rghc-timing -DDEBUG" >> mk/build.mk
#	echo "GhcLibHcOpts  += -O -dcore-lint -keep-hc-files " >> mk/build.mk
	echo "SplitObjs     = NO" >> mk/build.mk
	echo "STRIP         = :" >> mk/build.mk
endif
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	echo "SRC_HC_OPTS   += -H32m -O0" >> mk/build.mk
	echo "GhcHcOpts     += -O0" >> mk/build.mk
	# This breaks the build - to be investigated:
	# echo "GhcLibHcOpts  += -O0" >> mk/build.mk
	echo "GhcRtsCcOpts  += -O0" >> mk/build.mk
endif
	# We can't do this with a configure flag in 6.8.1 as libdir is not
	# defined at the point at which we := it
	echo 'ghclibdir := $${libdir}/ghc' >> mk/build.mk
	echo 'bindir  := $${ghclibdir}/bin' >> mk/build.mk
	echo 'ghclibexecdir := $${ghclibdir}/lib' >> mk/build.mk
	# docdir doesn't have a configure flag, and unfortunately
	# we also need to explicitly define all of its dependents as they
	# are set with :=
	echo 'docdir  := $$(datarootdir)/doc/ghc-doc' >> mk/build.mk
	echo 'htmldir := $$(docdir)'                   >> mk/build.mk
	echo 'dvidir  := $$(docdir)'                   >> mk/build.mk
	echo 'pdfdir  := $$(docdir)'                   >> mk/build.mk
	echo 'psdir   := $$(docdir)'                   >> mk/build.mk
	rm -f config.sub
	rm -f config.guess
	ln -s /usr/share/misc/config.sub .
	ln -s /usr/share/misc/config.guess .
	./configure $(confflags) --prefix=/usr $(EXTRA_CONFIGURE_FLAGS)

	touch $@

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	$(MAKE) $(MAKEFLAGS)

	# Do some very simple tests that the compiler actually works
	rm -rf debian/testghc
	mkdir debian/testghc
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*
	echo 'main = putStrLn "Foo"' > debian/testghc/foo.hs
	inplace/bin/ghc-stage2 debian/testghc/foo.hs -o debian/testghc/foo -O2
	[ "$$(debian/testghc/foo)" = "Foo" ]
	rm debian/testghc/*

# build haddock separately and hard code paths according to install paths
	mkdir -p debian/haddock-build
	cp -r utils/haddock debian/haddock-build
	cd debian/haddock-build/haddock; \
	        rm -rf dist; \
		../../../inplace/bin/ghc-stage2 --make Setup.lhs; \
		./Setup configure --prefix=/usr --with-compiler=../../../inplace/bin/ghc-stage2 \
			--package-db=../../../inplace/lib/package.conf.d/ \
			--htmldir=/usr/share/doc/ghc-haddock/html/ ; \
		./Setup build

	touch $@

FILES = \( -type f -o -type l \)
PROF_FILE = \( -name "*.p_*" -o -name "lib*_p.a" \)
DYNAMIC_FILE = \( -name "*.dyn_hi" -o -name lib*.so \)

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_prep

	# Install the basic stuff
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install

	# Delete all the library LICENSE files
	rm -f debian/tmp/usr/share/doc/ghc-doc/html/libraries/*/LICENSE

	# Generate lintian overrides
	mkdir -p debian/tmp/usr/share/lintian/overrides
	echo "ghc binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc: extra-license-file `cl debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.dyn_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc
	echo "ghc-prof binary: extra-license-file `cd debian/tmp && echo usr/lib/ghc-*/Cabal-*/Distribution/License.p_hi`" >> debian/tmp/usr/share/lintian/overrides/ghc-prof

	# Sort out the package.conf files
	mkdir -p debian/tmp/var/lib/ghc
	# Old directories for symlink-workaround. Remove once all libraries use new path
	mv debian/tmp/usr/lib/ghc/package.conf.d \
	   debian/tmp/var/lib/ghc/
	rm debian/tmp/var/lib/ghc/package.conf.d/package.cache
	chmod +x debian/provided_substvars
	debian/provided_substvars
	sed -ri 's,^haddock-interfaces: /.*?/libraries/,haddock-interfaces: /usr/lib/ghc-doc/haddock/,' debian/tmp/var/lib/ghc/package.conf.d/*.conf

	# Remove haddock as built within the ghc tree
	rm -f debian/tmp/usr/lib/ghc/bin/haddock \
	      debian/tmp/usr/lib/ghc/bin/haddock-$(ProjectVersion) \
	      debian/tmp/usr/lib/ghc/lib/haddock
	rm -rf debian/tmp/usr/lib/ghc/html

	# Sort out the binaries
	mkdir -p debian/tmp/usr/bin
	if inplace/bin/ghc-stage2 --info | grep '"Have interpreter","NO"'; then \
	    cd debian/tmp/usr/lib/ghc ;rm -f bin/ghci* bin/runghc* bin/runhaskell*; \
	fi
	cd debian/tmp/usr/lib/ghc/bin && \
	    for f in *; \
	    do ln -s /usr/lib/ghc/bin/$$f \
	             ../../../bin/$${f}; \
	    done
	sed -i 's,topdir="/usr/lib,topdir="/var/lib,' debian/tmp/usr/lib/ghc/bin/ghc-pkg-$(ProjectVersion)
	cd debian/haddock-build/haddock; ./Setup copy --dest=../../tmp

	# Check if we have a ghci binary
	if test -e debian/tmp/usr/lib/ghc/bin/ghci-$(ProjectVersion); then \
	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi

	# Add haddock substvars
	echo "haddock:Depends=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
	echo "haddock:Provides=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars

ifeq (YES,$(BUILD_HADDOCK_DOCS))
	mkdir -p debian/tmp/usr/lib/ghc-doc
	cp debian/gen_contents_index debian/tmp/usr/lib/ghc-doc/
	chmod +x debian/tmp/usr/lib/ghc-doc/gen_contents_index
	mkdir debian/tmp/usr/lib/ghc-doc/haddock/
	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; \

## ghc 7.4.0.20120108

=== debian/changelog ===
ghc (7.4.0.20120108-1) experimental; urgency=low

  * s/armef/armhf/ in debian/control 
  * New upstream release, drop all patches introduced in 7.4.0.20111219-3,
    applied upstream. 

 -- Joachim Breitner <nomeata@debian.org>  Mon, 09 Jan 2012 13:22:18 +0100

ghc (7.4.0.20111219-4) experimental; urgency=low

  * Prefix haddock interface number with "haddock-interface" in
    Depends/Provides pair
  * Switch to llvm and registered builds on arm* 
  * Do not set UseLibFFIForAdjustors in debian/rules, as the code in
    ./mk/config.mk.in seems to do the same anyways. 
  * Do not set GhcWithInterpreter=YES for kfreebsd-*, done in
    ./mk/config.mk.in by now. 
  * Do not set GhcUnregisterised=YES in debian/rules, ./mk/config.mk.in
    already makes the right choice. 
  * Do not build the accidentally included dph libraries. 
  * Explicitly depend on llv-3.0 and use corresponding binary names.

 -- Joachim Breitner <nomeata@debian.org>  Mon, 02 Jan 2012 20:39:42 +0100

ghc (7.4.0.20111219-3) experimental; urgency=low

  * patches/kfreebsd-OS: KFreeBSD is an ELF-based OK
  * patches/S390-Arch: Mention bitness of S390(x)
  * patches/ArchMips: Add more missing Arch values

 -- Joachim Breitner <nomeata@debian.org>  Fri, 30 Dec 2011 18:05:33 +0100

## ghc 7.4.0.20120126

=== debian/changelog ===
ghc (7.4.0.20120126-1) experimental; urgency=low

  * New upstream release candidate (7.4.1-rc2)

 -- Joachim Breitner <nomeata@debian.org>  Sat, 28 Jan 2012 13:31:10 -0500

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,9 @@
   ghc,
   grep-dctrl,
   autotools-dev,
+  autoconf,
   gcc (>= 4:4.2),
+  llvm-3.0 [armel armhf],
   libffi-dev,
   pkg-config,
   xsltproc,
@@ -25,12 +27,12 @@
 
 Package: ghc
 Architecture: any
-Depends: gcc (>= 4:4.2), libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
+Depends: gcc (>= 4:4.2), llvm-3.0 [armel armhf], libgmp-dev, libffi-dev, libbsd-dev, libc6-dev, ${shlibs:Depends}, ${misc:Depends}
 Provides: haskell-compiler, ${provided-devs}, ${haskell:Provides}, ${ghci}
 Replaces: ghc6 (<< 7)
 Conflicts: ghc6 (<< 7)
 Breaks: cabal-install (<< 0.8.0), haskell-devscripts (<< 0.6.19), ghc-doc (<= 6.12.1-8)
-Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm
+Suggests: perl, ghc-prof, ghc-doc, haskell-doc, llvm-3.0
 Description: The Glasgow Haskell Compilation system
  The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
  Haskell.
@@ -116,7 +118,7 @@
  Haddock can generate documentation in multiple formats; currently HTML
  is implemented, and there is partial support for generating DocBook.
  .
- This package contains Haddock version 2.9.4.
+ This package contains Haddock version 2.10.0.
 
 Package: ghc6
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -40,21 +40,12 @@
 configure-stamp:
 	dh_testdir
 
+	autoconf
+
 	rm -f mk/build.mk
 	echo "SRC_HC_OPTS += -lffi -optl-pthread" >> mk/build.mk
 	echo "HADDOCK_DOCS := YES" >> mk/build.mk
 	echo "XSLTPROC_OPTS += --nonet" >> mk/build.mk
-ifneq (,$(findstring $(DEB_HOST_ARCH), i386 amd64 kfreebsd-i386 kfreebsd-amd64 powerpc))
-	echo "GhcUnregisterised=NO" >> mk/build.mk
-else
-	echo "GhcUnregisterised=YES" >> mk/build.mk
-endif
-ifneq (,$(findstring $(DEB_HOST_ARCH), kfreebsd-i386 kfreebsd-amd64))
-	echo "GhcWithInterpreter=YES" >> mk/build.mk
-endif
-ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf alpha ia64))
-	echo "UseLibFFIForAdjustors=YES" >> mk/build.mk
-endif
 ifneq (,$(findstring $(DEB_HOST_ARCH), arm armel armhf))
 	echo "SRC_HC_OPTS     += -optc-mlong-calls" >> mk/build.mk
 endif
@@ -185,8 +176,8 @@
 	    echo 'ghci=ghc-ghci' >> debian/ghc.substvars ; fi
 
 	# Add haddock substvars
-	echo "haddock:Depends=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
-	echo "haddock:Provides=$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars
+	echo "haddock:Depends=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-doc.substvars
+	echo "haddock:Provides=haddock-interface-$$(debian/tmp/usr/bin/haddock --interface-version)" >> debian/ghc-haddock.substvars
 
 ifeq (YES,$(BUILD_HADDOCK_DOCS))
 	mkdir -p debian/tmp/usr/lib/ghc-doc
@@ -195,3 +186,9 @@
 	mkdir debian/tmp/usr/lib/ghc-doc/haddock/
 	for f in `find debian/tmp/usr/share/doc/ghc-doc/html/libraries/ -maxdepth 1 -mindepth 1 -type d`; do \
 	    mkdir debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; \
+	    mv $$f/*.haddock debian/tmp/usr/lib/ghc-doc/haddock/`basename $$f` ; done
+	cd debian/tmp/usr/share/doc/ghc-doc/html/libraries/; ln -s ghc-$(ProjectVersion) ghc
+	install -Dm 644 debian/index.html debian/tmp/usr/share/doc/ghc-doc/index.html
+endif
+
+ifeq (ia64,$(DEB_HOST_ARCH)) # Tested and seen to be necessary with 6.12.1
